/*
Drawboard - Java applet used to make graphical teleconferences
Copyright (C) 2001  Tomek "TomasH" Zielinski, tomash@fidonet.org.pl

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package drawboard;

// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// This class has a very dirty code.
// It is only work version, so please don't look at it.
// Nice-looking about box will be designed later.
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

import java.applet.AppletContext;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;

// =============================================================================
// =============================================================================
public class Copyright extends Dialog  implements Runnable, MouseMotionListener, MouseListener{
  final int WIDTH=600;
  final int HEIGHT=400;
  final int TEXTBOX_X=150;
  final int TEXTBOX_Y=100;
  final int TEXTBOXWIDTH=WIDTH-TEXTBOX_X-10;
  final int TEXTBOXHEIGHT=HEIGHT -TEXTBOX_Y-40;

  BufferedReader dis ;
  volatile String[] tekst;
  volatile Image image;
  volatile int scrolldirection=0;
  volatile int scrolldelay=500;
  volatile Graphics gimage=null;
  volatile boolean subthreadend=false;
  volatile int skip=0;
  AppletContext aplctx=null;

  // =============================================================================
  public void run(){
//    System.out.println("Subthread started");
    while(true){
      try{Thread.sleep(scrolldelay);}catch(Exception e){}
      skip=(skip+(scrolldirection))%(tekst.length*10);
      if (skip<0)skip=0;
      repaint(TEXTBOX_X,TEXTBOX_Y, TEXTBOXWIDTH, TEXTBOXHEIGHT);
      if (subthreadend==true){
//        System.out.println("Subthread stopped");
        return;
      }
    }
  }

  public void mouseEntered(MouseEvent e){}
  public void mouseExited(MouseEvent e){
    scrolldirection=0;
    scrolldelay=100;
  }
  public void mousePressed(MouseEvent e){}
  public void mouseReleased(MouseEvent e){}

  // =============================================================================
  public void mouseClicked(MouseEvent e){
    int X=e.getX();
    int Y=e.getY();
    try{
      if (X>10 && X<140 && Y>100 && Y<130){
        aplctx.showDocument(new URL("http://www.sf.net/projects/drawboard/"),"_blank");
      }
      if (X>10 && X<140 && Y>160 && Y<190){
        aplctx.showDocument(new URL("http://drawboard.sf.net/"),"_blank");
      }
      if (X>10 && X<140 && Y>220 && Y<250){
        aplctx.showDocument(new URL("mailto:tomash@fidonet.org.pl"),"_blank");
      }
    }catch(MalformedURLException ee){System.out.println("Home page error?!?");}
  }


  // =============================================================================
  public void mouseMoved(MouseEvent e){
    int X=e.getX()-TEXTBOX_X;
    int Y=e.getY()-TEXTBOX_Y;
    if (X>0 && Y>0 && X<TEXTBOXWIDTH && Y<TEXTBOXHEIGHT){
      double st=((double)Y/(double)TEXTBOXHEIGHT-0.5)*2.0;
      if (st<0) {scrolldirection=-1; }else{scrolldirection=1;};
      if (Math.abs(st)<0.1){
        scrolldirection=0;
        scrolldelay=100;
      }else if (Math.abs(st)<0.5){
        scrolldelay=30;
      }else if (Math.abs(st)<0.8){
        scrolldelay=15;
      }else{
        scrolldelay=5;
      }
    }
    else {
      scrolldirection=0;
      scrolldelay=500;
    }

    X=e.getX();
    Y=e.getY();
    if (
      (X>10 && X<140 && Y>100 && Y<130) ||
      (X>10 && X<140 && Y>160 && Y<190) ||
      (X>10 && X<140 && Y>220 && Y<250)
    ) this.setCursor(new Cursor(Cursor.HAND_CURSOR));
    else this.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
  }

  // =============================================================================
  public void mouseDragged(MouseEvent e){
    mouseMoved(e);
  }

  // =============================================================================
  public String filterFile(String file){
    int index = file.lastIndexOf("/");
    if ((index > -1) && (file.length() > index + 1))
      return (file.substring(0,index + 1));
    else return file;
  }

  // =============================================================================
  public Copyright(Frame owner, boolean modal, URL u, AppletContext apl) {
    super(owner, "Copyright & about information...", modal);
    aplctx=apl;
    addWindowListener(new WindowAdapter(){
      public void windowClosing(WindowEvent e){
        dispose();
      }
    });
    addMouseMotionListener(this);
    addMouseListener(this);

//    label = new MultiLineLabel("pierwsza\ndruga\ntrzeciaaaaaaaa");
//    panel.add(label);

    tekst=loadtext("LICENSE",u);

//    System.out.println(tekst.length);
    setResizable(false);
    setSize(WIDTH ,HEIGHT );
    Thread t=new Thread(this);
    subthreadend=false;
    t.start();
    show();
    subthreadend=true;
  }


  // =============================================================================
  String[] loadtext(String file, URL u){
    StringList list=new StringList();
    URL url=null;
    try {
      url=new URL(u.getProtocol(),u.getHost(),filterFile(u.getFile())+file);
    } catch (MalformedURLException e){
      System.out.println("The Url=bad");
    }

    try{
      dis= new BufferedReader(new InputStreamReader(url.openStream()));
    } catch (IOException e ) {
      System.out.println("IO Error");
      String[] str=new String[1];
      str[0]="File "+file+" load error";
      return str;
    }


    boolean readed=false;
    try{
      while(list.add(dis.readLine())){}
    }catch (IOException e) {
      readed=true;
    }

    int counter=list.getSize();
    String[] str=new String[counter];
    for (int a=0; a<counter; a++){
      str[a]=list.get();
    }
    return str;
  }

  // =============================================================================
  public void update(Graphics g){
    paint(g);
  }
  public void paint(Graphics g){
    if (image==null){
      image=createImage(TEXTBOXWIDTH ,TEXTBOXHEIGHT);
    }
    this.getToolkit().sync();
    g.setColor(Color.black);
    g.fillRect(0,0,WIDTH ,TEXTBOX_Y );
    g.fillRect(0,TEXTBOX_Y ,TEXTBOX_X ,TEXTBOXHEIGHT );
    g.fillRect(0,TEXTBOX_Y+TEXTBOXHEIGHT,WIDTH ,HEIGHT-TEXTBOX_Y-TEXTBOXHEIGHT);
    g.fillRect(TEXTBOX_X+TEXTBOXWIDTH,TEXTBOX_Y ,WIDTH-TEXTBOX_X-TEXTBOXWIDTH ,TEXTBOXHEIGHT );

    g.setFont(new Font("Arial", Font.BOLD, 20));
    FontMetrics fm = g.getFontMetrics();
    g.setColor(new Color(70,250,120));

    String str="DRAWBOARD";
    g.drawString(str,WIDTH/2-fm.stringWidth(str)/2,fm.getHeight()+40);

    g.drawString("v 0.56 BETA",10,350);

    g.setColor(Color.blue);
    g.drawRect(10,100,130,30);
    str="WWW";
    g.drawString(str,75-fm.stringWidth(str)/2,fm.getHeight()+100);

    g.drawRect(10,160,130,30);
    str="Manual";
    g.drawString(str,75-fm.stringWidth(str)/2,fm.getHeight()+160);

    g.drawRect(10,220,130,30);
    str="e-mail";
    g.drawString(str,75-fm.stringWidth(str)/2,fm.getHeight()+220);

    g.setFont(new Font("Arial", Font.BOLD, 12));
    fm = g.getFontMetrics();

    g.setColor(new Color(70,250,120));
    str=("Copyright (C) 2001  Tomek \"TomasH\" Zielinski, tomash@fidonet.org.pl");
    g.drawString(str,WIDTH/2-fm.stringWidth(str)/2,fm.getHeight()+70);


    preparetable();
    g.drawImage(image,TEXTBOX_X,TEXTBOX_Y,TEXTBOXWIDTH ,TEXTBOXHEIGHT,Color.black,this);
  }


  // =============================================================================
  void preparetable(){
    int step=14;
    int start=skip/step;
    if (gimage==null) gimage=image.getGraphics();

    gimage.setFont(new Font("Arial", Font.PLAIN, 12));
    FontMetrics fm = gimage.getFontMetrics();
    if (fm.charWidth('i') != fm.charWidth('w'))
      gimage.setFont(new Font("Courier", Font.PLAIN, 12));


    gimage.setColor(Color.black);
    gimage.fillRect(0,0,TEXTBOXWIDTH,TEXTBOXHEIGHT);
    gimage.setColor(Color.lightGray);
    for (int a=start;a<start+1+TEXTBOXHEIGHT/10;a++){
      if (a<tekst.length) gimage.drawString(tekst[a],10,10+(a-start)*step-skip%step);
    }
    gimage.setColor(Color.gray);
    gimage.drawRect(0,0,TEXTBOXWIDTH-1,TEXTBOXHEIGHT-1);
  }
}



// =============================================================================
// =============================================================================
class StringList{

  // =============================================================================
  class listelement{
    String str;
    listelement next;
    listelement(String s){
      str=s;
      next=null;
    }
    void setnext(listelement el){
      next=el;
    }
  }

  listelement first=null;
  listelement last=null;
  int size=0;

  // =============================================================================
  StringList(){
    first=null;
    last=null;
    size=0;
  }

  // =============================================================================
  boolean add(String str){
    if (str==null)return false;
    listelement el=new listelement(str);
    if (first==null) first=el;
    if (last!=null)last.setnext(el);
    last=el;
    size++;
    return true;
  }

  // =============================================================================
  int getSize(){
    return size;
  }

  // =============================================================================
  String get(){
    if (first==null) return null;
    String temp=first.str;
    first=first.next;
    return temp;
  }
}